package com.jpsoft.picc.test;

import com.jpsoft.picc.modules.common.config.OSSConfig;
import com.jpsoft.picc.modules.common.utils.OSSUtil;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RunWith(SpringRunner.class)
@SpringBootTest
public class OSSTest {
    @Autowired
    private OSSConfig ossConfig;

    @Test
    public void testUpload(){
        String fileName = "C:\\Users\\Administrator\\Desktop\\PICC\\企业人员名单导入模板.xls";

        try {
            FileInputStream fis = new FileInputStream(fileName);
            String fileUrl = OSSUtil.upload(ossConfig,"/template","companyMember.xls", fis);
            System.out.println(fileUrl);

            fis.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testDownload(){
        //http://vod.wzgh.org
        //?x-oss-process=image/resize,l_1024,limit_1
        //String fileUrl = "picc/test/2020/2/身份证.png";
        String fileUrl = "http://vod.wzgh.org/picc/test/2020/2/身份证.png?x-oss-process=image/resize,l_800,limit_1";
        Map<String,String> fileMap = new HashMap<>();
        fileMap.put(fileUrl,fileUrl);

        List<Map> fileList = new ArrayList<>();
        fileList.add(fileMap);

        FileOutputStream fos = null;

        try {
            fos = new FileOutputStream("H:\\test.zip");
//            OSSUtil.batchDownload(fileList,fos);
            OSSUtil.presignedDownload(ossConfig,fileList,fos);

            fos.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
