package com.jpsoft.picc.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;

/**
  描述:base_company的实体类
 */
@Data
@ApiModel(value = "base_company的实体类")
public class Company {
    @ApiModelProperty(value = "ID")
	private String id;
    @ApiModelProperty(value = "企业名称")
	private String name;
    @ApiModelProperty(value = "法人代表")
	private String legalName;
	@ApiModelProperty(value = "法人代表手机号")
	private String legalPhone;
    @ApiModelProperty(value = "法人代表身份证")
	private String legalCard;
    @ApiModelProperty(value = "法人代表身份证附件")
	private String legalCardFile;
    @ApiModelProperty(value = "证件编号")
	private String usccCode;
    @ApiModelProperty(value = "证件附件(营业执照/企业代码)")
	private String usccFiles;
    @ApiModelProperty(value = "企业类型")
	private String type;
    @ApiModelProperty(value = "营业性质")
	private String businessNature;
	@ApiModelProperty(value = "营业性质名称")
	private String businessNatureN;
    @ApiModelProperty(value = "营业范围")
	private String businessScope;
    @ApiModelProperty(value = "行业类型")
	private String industryType;
    @ApiModelProperty(value = "雇员人数")
	private Integer employeesNumber;
    @ApiModelProperty(value = "已投保人数")
	private Integer insuredNumber;
    @ApiModelProperty(value = "联系人")
	private String person;
    @ApiModelProperty(value = "联系电话")
	private String tel;
    @ApiModelProperty(value = "电子邮箱")
	private String mail;
    @ApiModelProperty(value = "邮政编码")
	private String postal;
    @ApiModelProperty(value = "地址")
	private String address;
    @ApiModelProperty(value = "企业公章(附件)")
	private String companyStampFile;
    @ApiModelProperty(value = "推广员账号")
	private String promoter;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "推广员绑定时间")
    private Date promoterBindTime;
	@ApiModelProperty(value = "云账号信息")
	private JpCloudUser jpCloudUser;
    @ApiModelProperty(value = "近三年损失情况（时间、原因、损失金额）")
	private String remark;
    @ApiModelProperty(value = "云平台买方ID")
	private String buyId;
    @ApiModelProperty(value = "状态")
	private String status;
    @ApiModelProperty(value = "创建人")
	private String createBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
	private Date createTime;
    @ApiModelProperty(value = "更新人")
	private String updateBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
    @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
}