package com.jpsoft.picc.modules.pub.controller;

import cn.hutool.core.util.RandomUtil;
import com.alibaba.druid.util.StringUtils;
import com.jpsoft.picc.modules.base.entity.Company;
import com.jpsoft.picc.modules.base.entity.CompanyUser;
import com.jpsoft.picc.modules.base.service.CompanyService;
import com.jpsoft.picc.modules.base.service.CompanyUserService;
import com.jpsoft.picc.modules.common.dto.MessageResult;
import com.jpsoft.picc.modules.common.utils.DES3;
import com.jpsoft.picc.modules.common.utils.PojoUtils;
import com.jpsoft.picc.modules.common.utils.SMSUtil;
import com.jpsoft.picc.modules.pub.dto.CompanyInfoDTO;
import com.jpsoft.picc.modules.pub.dto.PersonalInfoDTO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpSession;
import java.util.Date;
import java.util.UUID;

/***
 * 账户信息在荆鹏云中统一管理
 */
@Deprecated
@RestController
//@Api(description = "企业用户操作")
@RequestMapping("/companyUser")
public class CompanyUserController {
    @Autowired
    private CompanyUserService companyUserService;
    @Autowired
    private CompanyService companyService;

    @GetMapping(value="sendVerificationCode")
    @ApiOperation(value = "发送6位验证码")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "phone",value = "注册手机号", required = true, paramType = "form")
    })
    public MessageResult<String> sendVerificationCode(String phone, HttpSession session){
        int rndInt = RandomUtil.randomInt(100000,1000000);

        MessageResult<String> messageResult = SMSUtil.sendVerificationCode(phone,String.valueOf(rndInt));

        if (messageResult.isResult()) {
            session.setAttribute("valCode", rndInt);
        }

        return messageResult;
    }

    @PostMapping(value="quickRegister")
    @ApiOperation(value = "快速注册")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "phone",value = "注册手机号", required = true, paramType = "form"),
            @ApiImplicitParam(name = "code",value = "验证码", required = true, paramType = "form"),
    })
    public MessageResult<String> quickRegister(@RequestParam String phone,
                                               @RequestParam Integer code,
                                               HttpSession session){
        MessageResult<String> messageResult = new MessageResult<>();

        if (code.equals(session.getAttribute("valCode"))){
            CompanyUser companyUser = new CompanyUser();
            companyUser.setId(UUID.randomUUID().toString());
            companyUser.setPhone(phone);
            companyUser.setCreateTime(new Date());
            companyUser.setCreateBy(companyUser.getId());
            companyUser.setDelFlag(false);
            companyUser.setStatus("0");

            companyUserService.insert(companyUser);

            session.setAttribute("regCompanyUserId",companyUser.getId());

            messageResult.setData(companyUser.getId());
            messageResult.setResult(true);
        }
        else{
            messageResult.setMessage("验证码错误!");
            messageResult.setResult(false);
        }

        return messageResult;
    }
    
    @PostMapping(value="improveAccountInformation")
    @ApiOperation(value = "完善账户信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "companyUserId",value = "企业用户编号", required = true, paramType = "form"),
            @ApiImplicitParam(name = "userName",value = "用户名", required = true, paramType = "form"),
            @ApiImplicitParam(name = "password",value = "密码", required = true, paramType = "form"),
    })
    public MessageResult<String> improveAccountInformation(String companyUserId,String userName,String password){
        MessageResult<String> messageResult = new MessageResult<>();

        try {
            CompanyUser companyUser = companyUserService.get(companyUserId);

            if (StringUtils.isEmpty(companyUser.getUserName())
                    && StringUtils.isEmpty(companyUser.getPassword())){
                companyUser.setUserName(userName);

                DES3 des3 = new DES3();
                companyUser.setPassword(des3.encrypt(DES3.DEFAULT_KEY, password));

                companyUser.setUpdateBy(companyUserId);
                companyUser.setUpdateTime(new Date());
                companyUser.setStatus("1");

                companyUserService.update(companyUser);

                //云平台账户同步

                messageResult.setResult(true);
            }
            else{
                messageResult.setResult(false);
                messageResult.setMessage("账户信息已存在!");
            }
        }
        catch (Exception ex){
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }

    @GetMapping(value="getPersonalInformation")
    @ApiOperation(value = "获取个人信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "企业用户编号",value = "companyUserId", required = true, paramType = "query"),
    })
    public MessageResult<PersonalInfoDTO> getPersonalInformation(String companyUserId){
        MessageResult<PersonalInfoDTO> messageResult = new MessageResult<>();

        try {
            //todo
            CompanyUser companyUser = companyUserService.get(companyUserId);

            PersonalInfoDTO personalInfo = new PersonalInfoDTO();
            PojoUtils.map(companyUser,personalInfo);

            messageResult.setData(personalInfo);
            messageResult.setResult(true);
        }
        catch (Exception ex){
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }

    @PostMapping(value="updatePersonalInformation")
    @ApiOperation(value = "更新个人信息")
    public MessageResult<String> updatePersonalInformation(PersonalInfoDTO personalInfo){
        MessageResult<String> messageResult = new MessageResult<>();

        try {
            //todo
            CompanyUser companyUser = companyUserService.get(personalInfo.getId());
            PojoUtils.map(personalInfo,companyUser);

            companyUserService.update(companyUser);

            messageResult.setResult(true);
        }
        catch (Exception ex){
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }

    @PostMapping(value="updatePhoneNumber")
    @ApiOperation(value = "更新账户手机号")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "companyUserId",value = "企业用户编号", required = true, paramType = "form"),
            @ApiImplicitParam(name = "newPhoneNumber",value = "新手机号", required = true, paramType = "form"),
            @ApiImplicitParam(name = "code",value = "验证码", required = true, paramType = "form")
    })
    public MessageResult<String> updatePhoneNumber(String companyUserId,String newPhoneNumber,String code,HttpSession session){
        MessageResult<String> messageResult = new MessageResult<>();

        try {
            //todo
            if (code.equals(session.getAttribute("valCode"))){
                CompanyUser companyUser = companyUserService.get(companyUserId);

                companyUser.setPhone(newPhoneNumber);
                companyUser.setUpdateTime(new Date());
                companyUser.setUpdateBy(companyUserId);

                companyUserService.update(companyUser);
            }
        }
        catch (Exception ex){
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }

    @PostMapping(value="updatePassword")
    @ApiOperation(value = "更新密码")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "companyUserId",value = "企业用户编号", required = true, paramType = "form"),
            @ApiImplicitParam(name = "newPassword",value = "新密码", required = true, paramType = "form"),
            @ApiImplicitParam(name = "code",value = "验证码", required = true, paramType = "form")
    })
    public MessageResult<String> updatePassword(String companyUserId,String newPassword,String code,HttpSession session){
        MessageResult<String> messageResult = new MessageResult<>();

        try {
            //todo
            if (code.equals(session.getAttribute("valCode"))){
                CompanyUser companyUser = companyUserService.get(companyUserId);

                DES3 des3 = new DES3();
                companyUser.setPassword(des3.encrypt(DES3.DEFAULT_KEY,newPassword));
                companyUser.setUpdateTime(new Date());
                companyUser.setUpdateBy(companyUserId);

                companyUserService.update(companyUser);
            }
        }
        catch (Exception ex){
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }
}
