package com.jpsoft.picc.test;

import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.aliyun.oss.model.PutObjectResult;
import com.jpsoft.picc.modules.business.entity.InsuranceApplication;
import com.jpsoft.picc.modules.business.service.InsuranceApplicationService;
import com.jpsoft.picc.modules.common.config.OSSConfig;
import com.jpsoft.picc.modules.common.utils.OSSUtil;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.FileInputStream;
import java.util.Date;
import java.util.UUID;

@RunWith(SpringRunner.class)
@SpringBootTest
public class InsuranceApplicationTest {
    @Autowired
    private InsuranceApplicationService insuranceApplicationService;

    @Autowired
    private OSSConfig ossConfig;

    @Test
    public void testInsert(){
        InsuranceApplication model = new InsuranceApplication();

        model.setId(UUID.randomUUID().toString());
        model.setCreateBy("2142006");
        model.setCreateTime(new Date());

        insuranceApplicationService.insert(model);
    }

    @Test
    public void testUpload(){
        String filePath = "H:\\企业人员名单导入模板.xls";

        try {
            FileInputStream fileInput = new FileInputStream(filePath);

            OSS ossClient = new OSSClientBuilder().build(ossConfig.getEndpoint(),
                    ossConfig.getAccessKeyId(), ossConfig.getAccessKeySecret());

            // 上传文件流
            PutObjectResult result = ossClient.putObject(ossConfig.getBucketName(), "picc/template/2020/2/企业人员名单导入模板.xls", fileInput);

            // 关闭OSSClient
            ossClient.shutdown();
        }
        catch (Exception ex){
            ex.printStackTrace();
        }
    }
}
